Opened 2 years ago

Closed 2 years ago

Last modified 2 years ago

#61547 closed defect (fixed)

texlive fails to compile on BigSur Apple Silicon

Reported by: Gregory-Gelfond (Gregory Gelfond) Owned by: michaelld (Michael Dickens)
Priority: Normal Milestone:
Component: ports Version: 2.6.4
Keywords: bigsur arm64 Cc: drkp (Dan Ports), michaelld (Michael Dickens)
Port: texlive texlive-bin

Description

Invoking the command sudo port install texlive +full +letter on an Apple Silicon Mac running Big Sur fails building the dependency texlive-bin:

--->  Attempting to fetch tlpkg-TeXLive-2020.54632.tar.xz from https://distfiles.macports.org/texlive-bin
--->  Verifying checksums for texlive-bin
--->  Extracting texlive-bin
--->  Applying patches to texlive-bin
--->  Configuring texlive-bin
--->  Building texlive-bin
Error: Failed to build texlive-bin: command execution failed
Error: See /opt/local/var/macports/logs/_opt_local_var_macports_sources_rsync.macports.org_macports_release_tarballs_ports_tex_texlive-bin/texlive-bin/main.log for details.
Error: Follow https://guide.macports.org/#project.tickets to report a bug.
Error: Processing of port texlive failed

For reference I've attached the main.log file.

Attachments (1)

main.log (1.2 MB) - added by Gregory-Gelfond (Gregory Gelfond) 2 years ago.

Download all attachments as: .zip

Change History (9)

Changed 2 years ago by Gregory-Gelfond (Gregory Gelfond)

Attachment: main.log added

comment:1 Changed 2 years ago by michaelld (Michael Dickens)

Interesting. I'm updating to the Xcode 12.2 release (have the beta still). It looks like there's a bug in <math.h> ... but, better practice by the TeXlive folks would be to use isfinite rather than finite since the former is what the current hip-and-trendy kids use while the latter is for backwards compatibility only / sort of deprecated but not yet removed. Need to check the TeXlive source to see if they have fixed this issue yet.

comment:2 Changed 2 years ago by michaelld (Michael Dickens)

Cc: michaelld added

comment:3 Changed 2 years ago by michaelld (Michael Dickens)

FYI if you want to "hack" math.h ... line 742 in the 12.2 beta currently reads:

#if defined __i386__ || defined __x86_64__

and IMHO should read:

#if defined __i386__ || defined __x86_64__ || defined __arm64__

to include support for ARM64 ... that is, unless Apple is explicitly dropping support for the legacy BSD API with the move to Apple Silicon ... hmmm ....

comment:4 Changed 2 years ago by michaelld (Michael Dickens)

The source code in question was last updated "Mon Feb 3 13:01:31 2014" ... so, that might explain why it still uses an old API. Whatevers. Making a patch for MP.

comment:5 Changed 2 years ago by michaelld (Michael Dickens)

comment:6 Changed 2 years ago by michaelld (Michael Dickens)

Owner: set to michaelld
Resolution: fixed
Status: newclosed

In 69a03775ca2597d548251911b9a6aed1a47df265/macports-ports (master):

texlive-bin: add patch to fix build on ARM64

Use "infinite" rather than "finite" since Apple seems to have removed support for the latter in favor of the former on ARM64 only. Support remains for Intel 32 and 64 bit for both versions (See math.h line 550). This PR might also allow the port to build on PPC 32/64.

Closes: #61547

comment:7 Changed 2 years ago by kencu (Ken)

I never had any trouble installing texlive-* on Tiger or Leopard PPC:

2.108_0+texlive platform='darwin 8' archs='ppc' date='2019-01-29T08:26:15-0800'
  lcdf-typetools @2.108_1+texlive (active) platform='darwin 8' archs='ppc' date='2020-08-22T01:40:38-0700'
  texlive-basic @50893_0+doc platform='darwin 8' archs='noarch' date='2019-05-28T09:09:13-0700'
  texlive-basic @54624_1+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T01:07:07-0700'
  texlive-bin @2019.50896_2+x11 platform='darwin 8' archs='ppc' date='2019-11-05T19:56:24-0800'
  texlive-bin @2019.50896_3+x11 platform='darwin 8' archs='ppc' date='2020-07-08T09:19:45-0700'
  texlive-bin @2020.54632_2+x11 (active) platform='darwin 8' archs='ppc' date='2020-08-22T01:05:59-0700'
  texlive-bin-extra @47446_0+doc platform='darwin 8' archs='noarch' date='2018-06-24T14:50:41-0700'
  texlive-bin-extra @54608_0+doc platform='darwin 8' archs='noarch' date='2020-11-02T22:19:44-0800'
  texlive-bin-extra @54608_1+doc (active) platform='darwin 8' archs='noarch' date='2020-11-19T01:40:29-0800'
  texlive-common @2019_0 platform='darwin 8' archs='noarch' date='2019-05-28T08:25:57-0700'
  texlive-common @2020_0 (active) platform='darwin 8' archs='noarch' date='2020-08-22T00:08:41-0700'
  texlive-context @50709_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:55:42-0700'
  texlive-context @54364_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T12:18:23-0700'
  texlive-fonts-recommended @49603_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:45:51-0700'
  texlive-fonts-recommended @54512_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T12:08:18-0700'
  texlive-generic-recommended @39710_0+doc platform='darwin 8' archs='noarch' date='2017-03-30T17:39:11-0700'
  texlive-latex @50741_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:31:31-0700'
  texlive-latex @54498_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T01:36:35-0700'
  texlive-latex-extra @50885_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T20:22:46-0700'
  texlive-latex-recommended @50818_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:37:03-0700'
  texlive-latex-recommended @54586_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T11:59:36-0700'
  texlive-math-extra @41196_1+doc platform='darwin 8' archs='noarch' date='2017-03-30T17:37:41-0700'
  texlive-math-science @50760_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:50:05-0700'
  texlive-math-science @54588_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T12:12:24-0700'
  texlive-metapost @50602_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:34:09-0700'
  texlive-metapost @54512_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T11:56:56-0700'
  texlive-pictures @50872_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T20:03:26-0700'
  texlive-pictures @54512_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T02:21:38-0700'
  texlive-plain-generic @50884_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:39:47-0700'
  texlive-plain-generic @54476_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T12:01:46-0700'
  texlive-tlpdb @2020.54632_0 (active) platform='darwin 8' archs='noarch' date='2020-11-02T22:16:36-0800'
  texlive-xetex @50852_0+doc platform='darwin 8' archs='noarch' date='2019-05-29T19:41:54-0700'
  texlive-xetex @54512_0+doc (active) platform='darwin 8' archs='noarch' date='2020-08-22T12:04:06-0700'

comment:8 Changed 2 years ago by kencu (Ken)

and while I'm at it, you'll love this one:

$ port -v installed octave
The following ports are currently installed:
  octave @5.2.0_6+accelerate+app+docs+gfortran+graphicsmagick+qt4+sound+sundials (active) platform='darwin 8' archs='ppc' date='2020-11-04T12:36:17-0800'
Note: See TracTickets for help on using tickets.